# Send an einvoice for invoices

> For the complete machine-readable documentation index, see [llms.txt](https://apidocs.chargebee.com/llms.txt).


[Idempotency Supported](/docs/api/idempotency)

This endpoint is used to send an e-invoice for invoice. To support cases like TDS and invoice edits, we need to stop auto e-invoice sending and be able to send e-invoices manually. This endpoint schedules e-invoices manually. This operation is not allowed when any of the following condition matches:

-   If e-invoicing is not enabled at the site and customer level.
    
-   If there is an e-invoice generated already for the invoice.
    
-   If the **Use automatic e-invoicing** option is selected.
    
-   If there are no generated e-invoices with the `failed` or `skipped` status.
    
-   If the invoice status is `voided` or `pending`.

## Sample Request

#### cURL

```bash
curl  https://{site}.chargebee.com/api/v2/invoices/__demo_inv__1/send_einvoice \
     -X POST  \
     -u {site_api_key}:
```

#### .NET

```dotnet
using ChargeBee.Api;
using ChargeBee.Models;

ApiConfig.Configure("{site}","{site_api_key}");
EntityResult result = Invoice.SendEinvoice("__demo_inv__1").Request();

Invoice invoice = result.Invoice;
```

#### Go

```go
package main
import (
    "fmt"
    "github.com/chargebee/chargebee-go/v3"
    invoiceAction "github.com/chargebee/chargebee-go/v3/actions/invoice"
)
func main() {
    chargebee.Configure("{site_api_key}","{site}");
    res,err := invoiceAction.SendEinvoice("__demo_inv__1").Request()
    if err != nil {
        fmt.Println(err)
    } else {
        Invoice := res.Invoice
    }
}
```

#### Go

```go
package main

import (
  "fmt"
  "github.com/chargebee/chargebee-go/v4"
)

func main() {
  config := &chargebee.ClientConfig{
    SiteName: "{site}",
    ApiKey: "{site_api_key}",
  }    
  client := chargebee.NewClient(config)
  
  res, err := client.Invoice.SendEinvoice("__demo_inv__1")
      if err != nil {
        fmt.Println(err)
    } else {
        Invoice := res.Invoice
    }
}
```

#### Java

```java
import com.chargebee.*;
import com.chargebee.ListResult;
import com.chargebee.models.*;
import com.chargebee.models.enums.*;
import java.io.IOException;

public class Sample {

    public static void main(String args[]) throws IOException, Exception {
        Environment.configure("{site}", "{site_api_key}");
        Result result = Invoice.sendEinvoice("__demo_inv__1").request();

        Invoice invoice = result.invoice();
    }
}
```

#### Java

```java
import com.chargebee.v4.client.ChargebeeClient;
import com.chargebee.v4.models.invoice.Invoice;
import com.chargebee.v4.models.invoice.params.SendEinvoiceParams;
import com.chargebee.v4.models.invoice.responses.SendEinvoiceResponse;

public class SendEinvoice {

    public static void main(String[] args) {
        ChargebeeClient client = ChargebeeClient.builder()
            .apiKey("{site_api_key}")
            .siteName("{site}")
            .build();

        SendEinvoiceResponse response = client.invoices().sendEinvoice("__demo_inv__1");

        Invoice invoice = response.getInvoice();
    }
}
```

#### Node.js

```node
import Chargebee from "chargebee";

const chargebee = new Chargebee({
    site: "{site}",
    apiKey: "{site_api_key}",
});

try {
    const result = await chargebee.invoice.sendEinvoice("__demo_inv__1");

    console.log(result);
    const invoice = result.invoice;
} catch (err) {
    console.log(err);
}
```

#### PHP

```php
<?php

require __DIR__ . '/vendor/autoload.php';

use Chargebee\ChargebeeClient;

$chargebee = new ChargebeeClient(options: [
    "site" => "{site}",
    "apiKey" => "{site_api_key}",
]);
$result = $chargebee->invoice()->sendEinvoice("__demo_inv__1");
$invoice = $result->invoice;
```

#### Python

```python
from chargebee import Chargebee

cb_client = Chargebee(api_key="{site_api_key}", site="{site}")
response = cb_client.Invoice.send_einvoice("__demo_inv__1")
invoice = response.invoice
```

#### Ruby

```ruby
require 'chargebee'

ChargeBee.configure(:site => "{site}",
  :api_key => "{site_api_key}")

result = ChargeBee::Invoice.send_einvoice("__demo_inv__1")

invoice = result.invoice
```

## Sample Response

```json
{
  "invoice": {
    "adjustment_credit_notes": {},
    "amount_adjusted": 0,
    "amount_due": 0,
    "amount_paid": 1000,
    "amount_to_collect": 0,
    "applied_credits": {},
    "base_currency_code": "USD",
    "billing_address": {
      "first_name": "Duncan",
      "last_name": "Walpole",
      "object": "billing_address",
      "validation_status": "not_validated"
    },
    "channel": "web",
    "credits_applied": 0,
    "currency_code": "USD",
    "customer_id": "__test__8aswXTV3cHBBk",
    "date": 1517462002,
    "deleted": false,
    "due_date": 1517462002,
    "dunning_attempts": {},
    "exchange_rate": 1,
    "first_invoice": true,
    "generated_at": 1517462002,
    "has_advance_charges": false,
    "id": "__demo_inv__1",
    "is_gifted": false,
    "issued_credit_notes": {},
    "einvoice": {
      "id": "HmaT0avT2mtbTL3mR",
      "status": "scheduled",
      "message": "E-invoice sending is scheduled and not yet processed.",
      "object": "einvoice"
    },
    "line_items": [
      {
        "amount": 1000,
        "customer_id": "__test__8aswXTV3cHBBk",
        "date_from": 1517462002,
        "date_to": 1517462002,
        "description": "Support Charge",
        "discount_amount": 0,
        "entity_type": "adhoc",
        "id": "li___test__8aswXTV3cHWst",
        "is_taxed": false,
        "item_level_discount_amount": 0,
        "object": "line_item",
        "pricing_model": "flat_fee",
        "quantity": 1,
        "tax_amount": 0,
        "tax_exempt_reason": "tax_not_configured",
        "unit_amount": 1000
      },
      {..}
    ],
    "linked_orders": {},
    "linked_payments": [
      {
        "applied_amount": 1000,
        "applied_at": 1517462002,
        "txn_amount": 1000,
        "txn_date": 1517462002,
        "txn_id": "txn___test__8aswXTV3cHZEu",
        "txn_status": "success"
      },
      {..}
    ],
    "net_term_days": 0,
    "new_sales_amount": 1000,
    "object": "invoice",
    "paid_at": 1517462002,
    "price_type": "tax_exclusive",
    "recurring": false,
    "resource_version": 1517462003147,
    "round_off_amount": 0,
    "status": "paid",
    "sub_total": 1000,
    "tax": 0,
    "term_finalized": true,
    "total": 1000,
    "updated_at": 1517462003,
    "write_off_amount": 0
  }
}
```

## URL Format

**POST** https://[site].chargebee.com/api/v2/invoices/{invoice-id}/send_einvoice

## Returns

- `invoice` (Invoice object)
  Resource object representing invoice
